package com.fr.solution.plugin.design.formula.compat;

import com.fanruan.api.util.GeneralKit;
import com.fanruan.api.util.StringKit;
import com.fr.stable.script.Function;

import java.util.Locale;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019-09-03
 */
public class FunctionNAD extends AbstractNameAndDescription {

    private static final String LOCALE_PREFIX = "Fine-Core_Formula_";

    private Function fn;

    FunctionNAD(Function fn) {
        this.fn = fn;
    }

    public String getName() {
        return fn == null ? StringKit.EMPTY : fn.getClass().getSimpleName();
    }

    public String getDesc() {
        if (fn == null) {
            return StringKit.EMPTY;
        }
        Locale locale = GeneralKit.getLocale();
        String describtion = fn.getDescription(locale);
        if (describtion.startsWith(LOCALE_PREFIX)) {
            return Locale.CHINA.equals(locale) ? fn.getCN() : fn.getEN();
        }

        return describtion;
    }

    @Override
    public String searchResult(String keyWord, boolean findDescription) {
        String functionName = getName();
        String des = getDesc();
        if (findDescription && des.contains(keyWord)) {
            return functionName;
        } else {
            return super.searchResult(keyWord, findDescription);
        }
    }
}
