package com.fr.solution.plugin.design.formula.compat;

import com.fr.design.formula.FunctionGroup;
import com.fr.design.formula.NameAndDescription;
import com.fr.stable.script.Function;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * 名称对应的函数列表
 *
 * @author Kalven
 * @version 10.0
 * Created by Kalven on 2019/8/31
 */
public class NameAndFunctionList implements FunctionGroup {

    protected String name;
    protected List<Function> fnList = new ArrayList<>();

    public NameAndFunctionList(String var1, Function[] var2) {
        this.name = var1;
        this.fnList.addAll(Arrays.asList(var2));
    }

    public String getGroupName() {
        return this.name;
    }

    public NameAndDescription[] getDescriptions() {
        NameAndDescription[] var1 = new NameAndDescription[this.fnList.size()];

        for (int var2 = 0; var2 < var1.length; ++var2) {
            var1[var2] = new FunctionNAD(this.fnList.get(var2));
        }

        return var1;
    }
}
